#include <linux/module.h>
#include <linux/skbuff.h>
#include <linux/ip.h>
#include <linux/udp.h>
#include <linux/tcp.h>
#include <linux/icmp.h>
#include <net/checksum.h>

#include <linux/netfilter_ipv4/ip_tables.h>

static int
match(const struct sk_buff *skb,
      const struct net_device *in,
      const struct net_device *out,
      const void *matchinfo,
      int offset,
      const void *hdr,
      u_int16_t datalen,
      int *hotdrop)
{
	unsigned int loffset;
	loffset = ntohs(skb->nh.iph->frag_off) & IP_OFFSET;
	//if (loffset * 8 + datalen > 65535) {
	if (loffset * 8 + datalen > 65530) {
		return 1;
	}
	return 0;
}

/* Called when user tries to insert an entry of this type. */
static int
checkentry(const char *tablename,
	   const struct ipt_ip *ip,
	   void *matchinfo,
	   unsigned int matchsize,
	   unsigned int hook_mask)
{
	if (matchsize != IPT_ALIGN(0))
		return 0;

	return 1;
}

static struct ipt_match pod_match
= { { NULL, NULL }, "pod", &match, &checkentry, NULL, THIS_MODULE };

static int __init init(void)
{
	return ipt_register_match(&pod_match);
}

static void __exit fini(void)
{
	ipt_unregister_match(&pod_match);
}

module_init(init);
module_exit(fini);
MODULE_LICENSE("GPL");
