#ifndef MEMDEBUG_H
#define MEMDEBUG_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <pthread.h>

#define calloc(n,t) my_calloc(n,t,__LINE__,__FILE__)
#define malloc(t) my_malloc(t,__LINE__,__FILE__)
#define realloc(p,t) my_realloc(p,t,__LINE__,__FILE__)
#define free(p) my_free(p,__LINE__,__FILE__)
#define strdup(p) my_strdup(p,__LINE__,__FILE__)

#if 0
#define open(a,b) my_open(a,b,__LINE__,__FILE__)
#define socket(a,b,c) my_socket(a,b,c,__LINE__,__FILE__)
#define accept(a,b,c) my_accept(a,b,c,__LINE__,__FILE__)
#define dup(a) my_dup(a,__LINE__,__FILE__)
//dup2???
#define close(a) my_close(a,__LINE__,__FILE__)
#define fopen(a,b) my_fopen(a,b,__LINE__,__FILE__)
#define fclose(a) my_fclose(a,__LINE__,__FILE__)
#endif

void *my_calloc(size_t nmemb, size_t nbytes, int iline, char *pcfile);
void *my_malloc(size_t nbytes, int iline, char *pcfile);
void *my_realloc(void * aptr, size_t nbytes, int iline, char *pcfile);
void my_free(void * aptr, int iline, char *pcfile);
char *my_strdup(const char *str, int iline, char *pcfile);
void pt_mem_result();

#if 0
int my_open(const char *pathname, int flags, int iline, char *pcfile);
int my_socket(int domain, int type, int protocol, int iline, char *pcfile);
int my_accept(int s, struct sockaddr *addr, int *addrlen, int iline, char *pcfile);

int my_close(int fd, int iline, char *pcfile);
FILE *my_fopen(const char *path, const char *mode, int iline, char *pcfile);
int my_fclose(FILE *stream, int iline, char *pcfile);
#endif
#endif
