///////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2003 C++ to C Made by PC32 Lsshi
// All rights reserved. 

///////////////////////////////////////////////////////////////////////////
#ifndef _GATE_H_
#define _GATE_H_

#include "upnp.h"

#include "ipcon.h"
#include "pmlist.h"

typedef struct _Gate
{

		PortMapList m_list;
		UpnpDevice_Handle device_handle;
		char *gate_udn;
		IPCon *m_ipcon;
		
		// State Variables
		//char m_ConnectionType[50];
		//char m_PossibleConnectionTypes[50];
		//char m_ConnectionStatus[20];
		long int startup_time;
		//char LastConnectionError[35];
		//long int m_AutoDisconnectTime;
		//long int m_IdleDisconnectTime;
		//long int m_WarnDisconnectDelay;
		//char RSIPAvailable;
		//char NATEnabled;
		//char m_ExternalIPAddress[20];
		//int m_PortMappingNumberOfEntries;
		//char m_PortMappingEnabled;
		
		void (*Gate_Void_Init)(struct _Gate* pGate);
		void (*Gate_Void_Destroy)(struct _Gate* pGate);
		
		int (*GateDeviceHandleSubscriptionRequest)(struct _Gate* pGate,struct Upnp_Subscription_Request *sr_event);
		int (*GateDeviceStateTableInit)(struct _Gate* pGate,char *DescDocURL);
		int (*GateDeviceHandleActionRequest)(struct _Gate* pGate,struct Upnp_Action_Request *ca_event);
		int (*GateDeviceCallbackEventHandler)(struct _Gate* pGate,Upnp_EventType EventType, void *Event, void *Cookie);
		int (*GateDeviceGetExternalIPAddress)(struct _Gate* pGate,struct Upnp_Action_Request *ca_event);
		int (*GateDeviceAddPortMapping)(struct _Gate* pGate,struct Upnp_Action_Request *ca_event);
		int (*GateDeviceDeletePortMapping)(struct _Gate* pGate,struct Upnp_Action_Request *ca_event);
		int (*GateDeviceGetStatusInfo)(struct _Gate* pGate,struct Upnp_Action_Request *ca_event);
		
		
             int (*GateDeviceGetTotalBytesSent)(struct _Gate* pGate,struct Upnp_Action_Request *ca_event);
             int (*GateDeviceGetTotalBytesReceived)(struct _Gate* pGate,struct Upnp_Action_Request *ca_event);
             int (*GateDeviceGetTotalPacketsSent)(struct _Gate* pGate,struct Upnp_Action_Request *ca_event);
             int (*GateDeviceGetTotalPacketsReceived)(struct _Gate* Gate,struct Upnp_Action_Request *ca_event);
             


//No pGate input func	
		
		int (*GateDeviceHandleGetVarRequest)(struct Upnp_State_Var_Request *cg_event);
		int (*GateDeviceSetConnectionType)(struct Upnp_Action_Request *ca_event);
		int (*GateDeviceGetConnectionTypeInfo)(struct Upnp_Action_Request *ca_event);
		int (*GateDeviceRequestConnection)(struct Upnp_Action_Request *ca_event);
		int (*GateDeviceRequestTermination)(struct Upnp_Action_Request *ca_event);
		int (*GateDeviceForceTermination)(struct Upnp_Action_Request *ca_event);
		int (*GateDeviceSetAutoDisconnectTime)(struct Upnp_Action_Request *ca_event);
		int (*GateDeviceSetIdleDisconnectTime)(struct Upnp_Action_Request *ca_event);
		int (*GateDeviceSetWarnDisconnectDelay)(struct Upnp_Action_Request *ca_event);
		
		int (*GateDeviceGetAutoDisconnectTime)(struct Upnp_Action_Request *ca_event);
		int (*GateDeviceGetIdleDisconnectTime)(struct Upnp_Action_Request *ca_event);
		int (*GateDeviceGetWarnDisconnectDelay)(struct Upnp_Action_Request *ca_event);
		int (*GateDeviceGetNATRSIPStatus)(struct Upnp_Action_Request *ca_event);
		int (*GateDeviceGetGenericPortMappingEntry)(struct Upnp_Action_Request *ca_event);
		int (*GateDeviceGetSpecificPortMappingEntry)(struct Upnp_Action_Request *ca_event);
		
		int (*GateDeviceX)(struct Upnp_Action_Request *ca_event);
		int (*GateDeviceGetCommonLinkProperties)(struct Upnp_Action_Request *ca_event);
			
}Gate;


void _Gate_Void_Init(struct _Gate* pGate);
void _Gate_Void_Destroy(struct _Gate* pGate);

int _GateDeviceHandleSubscriptionRequest(struct _Gate* pGate,struct Upnp_Subscription_Request *sr_event);
int _GateDeviceStateTableInit(struct _Gate* pGate,char *DescDocURL);
int _GateDeviceHandleActionRequest(struct _Gate* pGate,struct Upnp_Action_Request *ca_event);
int _GateDeviceCallbackEventHandler(struct _Gate* pGate,Upnp_EventType EventType, void *Event, void *Cookie);
int _GateDeviceGetExternalIPAddress(struct _Gate* pGate,struct Upnp_Action_Request *ca_event);
int _GateDeviceAddPortMapping(struct _Gate* pGate,struct Upnp_Action_Request *ca_event);
int _GateDeviceDeletePortMapping(struct _Gate* pGate,struct Upnp_Action_Request *ca_event);
int _GateDeviceGetStatusInfo(struct _Gate* pGate,struct Upnp_Action_Request *ca_event);


int _GateDeviceGetTotalBytesSent(struct _Gate* pGate,struct Upnp_Action_Request *ca_event);
int _GateDeviceGetTotalBytesReceived(struct _Gate* pGate,struct Upnp_Action_Request *ca_event);
int _GateDeviceGetTotalPacketsSent(struct _Gate* pGate,struct Upnp_Action_Request *ca_event);
int _GateDeviceGetTotalPacketsReceived(struct _Gate* pGate,struct Upnp_Action_Request *ca_event);


//No pGate input func	
		
int _GateDeviceHandleGetVarRequest(struct Upnp_State_Var_Request *cg_event);
int _GateDeviceSetConnectionType(struct Upnp_Action_Request *ca_event);
int _GateDeviceGetConnectionTypeInfo(struct Upnp_Action_Request *ca_event);
int _GateDeviceRequestConnection(struct Upnp_Action_Request *ca_event);
int _GateDeviceRequestTermination(struct Upnp_Action_Request *ca_event);
int _GateDeviceForceTermination(struct Upnp_Action_Request *ca_event);
int _GateDeviceSetAutoDisconnectTime(struct Upnp_Action_Request *ca_event);
int _GateDeviceSetIdleDisconnectTime(struct Upnp_Action_Request *ca_event);
int _GateDeviceSetWarnDisconnectDelay(struct Upnp_Action_Request *ca_event);


int _GateDeviceGetAutoDisconnectTime(struct Upnp_Action_Request *ca_event);
int _GateDeviceGetIdleDisconnectTime(struct Upnp_Action_Request *ca_event);
int _GateDeviceGetWarnDisconnectDelay(struct Upnp_Action_Request *ca_event);
int _GateDeviceGetNATRSIPStatus(struct Upnp_Action_Request *ca_event);
int _GateDeviceGetGenericPortMappingEntry(struct Upnp_Action_Request *ca_event);
int _GateDeviceGetSpecificPortMappingEntry(struct Upnp_Action_Request *ca_event);

int _GateDeviceX(struct Upnp_Action_Request *ca_event);
int _GateDeviceGetCommonLinkProperties(struct Upnp_Action_Request *ca_event);
		
#endif
