///////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2003 C++ to C Made by PC32 Lsshi
// All rights reserved. 

///////////////////////////////////////////////////////////////////////////

#include <time.h>
//#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <syslog.h>
#include <signal.h>
#include "upnp.h"

#include "ipcon.h"
#include "sample_util.h"
#include "portmap.h"
#include <pthread.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include "pmlist.h"
#include "gate.h"
#include <sys/types.h>
#include <sys/stat.h>

// The global GATE object
Gate gate;

#include "main.h"
//#include "version.h"
//lsshi add 2003-8-22 13:42
#include <errno.h>
#include <net/route.h>
#include <sys/ioctl.h>

#include "routeutil.h"
#include "notify.h"

#define BOOL int
#define TRUE 1
#define FALSE 0
//
#define GATEDESC_FILE_ORIG	"/etc/linuxigd/gatedesc_templet.xml"
#define GATEDESC_FILE_NEW	"/tmp/gatedesc.xml"

int subXmlStr(char *docpath, char *infile, char *outfile, char *str_from, char *str_to);

int copy_desc()
{
	FILE *fpo;
	FILE *fpi;
	char buffi[2048];
	int len_buff;

	if ((fpi = fopen(GATEDESC_FILE_ORIG,"r")) == NULL) {
		printf("file can not be opened %s\n",GATEDESC_FILE_ORIG);
		fclose(fpi);
		return ;
	}

	if ((fpo = fopen(GATEDESC_FILE_NEW,"w")) == NULL) {
		printf("file can not be opened %s\n",GATEDESC_FILE_NEW);
		fclose(fpo);
		return ;
	}

	while (fgets(buffi, sizeof(buffi)-1, fpi) != NULL)
	{
		len_buff = strlen(buffi);
		fputs(buffi, fpo);
	}

	fclose(fpi);
	fclose(fpo);

}

void write_pid()
{
	pid_t d_id;
	FILE *fpd;

	d_id=getpid();

	 if((fpd=fopen("/var/run/upnp.pid","w+b"))==NULL)
	 {
		 printf("UPnP create pid file error !\n");
		 return;
	 }
	 fclose(fpd);
	 
         return;
}

void C_IPCon_Init(struct _IPCon* pIPCon);

void C_PortMapList_Init(struct _PortMapList* plist);

pthread_mutex_t Del_Mutex = PTHREAD_MUTEX_INITIALIZER;//lsshi add 2003-8-22 14:01

void Destroy_Rules(void)
{	
	pthread_mutex_lock(&Del_Mutex);
	
	gate.m_list.PortMapList_Void_Destroy(&gate.m_list);
	
	C_PortMapList_Init(&gate.m_list);
	_PortMapList_Void_Init(&gate.m_list);
	
	pthread_mutex_unlock(&Del_Mutex);

	
}

void C_Init(Gate* pgate)
{
	pgate->Gate_Void_Init=_Gate_Void_Init;
	pgate->Gate_Void_Destroy=_Gate_Void_Destroy;
	pgate->GateDeviceHandleSubscriptionRequest=_GateDeviceHandleSubscriptionRequest;
	pgate->GateDeviceStateTableInit=_GateDeviceStateTableInit;
	pgate->GateDeviceHandleGetVarRequest=_GateDeviceHandleGetVarRequest;
	pgate->GateDeviceHandleActionRequest=_GateDeviceHandleActionRequest;
	pgate->GateDeviceCallbackEventHandler=_GateDeviceCallbackEventHandler;
	pgate->GateDeviceSetConnectionType=_GateDeviceSetConnectionType;
	pgate->GateDeviceGetConnectionTypeInfo=_GateDeviceGetConnectionTypeInfo;
	pgate->GateDeviceRequestConnection=_GateDeviceRequestConnection;
	pgate->GateDeviceRequestTermination=_GateDeviceRequestTermination;
	pgate->GateDeviceForceTermination=_GateDeviceForceTermination;
	pgate->GateDeviceSetAutoDisconnectTime=_GateDeviceSetAutoDisconnectTime;
	pgate->GateDeviceSetIdleDisconnectTime=_GateDeviceSetIdleDisconnectTime;
	pgate->GateDeviceSetWarnDisconnectDelay=_GateDeviceSetWarnDisconnectDelay;
	pgate->GateDeviceGetStatusInfo=_GateDeviceGetStatusInfo;
	pgate->GateDeviceGetAutoDisconnectTime=_GateDeviceGetAutoDisconnectTime;
	pgate->GateDeviceGetIdleDisconnectTime=_GateDeviceGetIdleDisconnectTime;
	pgate->GateDeviceGetWarnDisconnectDelay=_GateDeviceGetWarnDisconnectDelay;
	pgate->GateDeviceGetNATRSIPStatus=_GateDeviceGetNATRSIPStatus;
	pgate->GateDeviceGetGenericPortMappingEntry=_GateDeviceGetGenericPortMappingEntry;
	pgate->GateDeviceGetSpecificPortMappingEntry=_GateDeviceGetSpecificPortMappingEntry;
	pgate->GateDeviceGetExternalIPAddress=_GateDeviceGetExternalIPAddress;
	pgate->GateDeviceAddPortMapping=_GateDeviceAddPortMapping;
	pgate->GateDeviceDeletePortMapping=_GateDeviceDeletePortMapping;
	
	
	pgate->GateDeviceX=_GateDeviceX;
	pgate->GateDeviceGetCommonLinkProperties=_GateDeviceGetCommonLinkProperties;
	pgate->GateDeviceGetTotalBytesSent=_GateDeviceGetTotalBytesSent;
	pgate->GateDeviceGetTotalBytesReceived=_GateDeviceGetTotalBytesReceived;
	pgate->GateDeviceGetTotalPacketsSent=_GateDeviceGetTotalPacketsSent;
	pgate->GateDeviceGetTotalPacketsReceived=_GateDeviceGetTotalPacketsReceived;
	

	C_PortMapList_Init(&pgate->m_list);
	_PortMapList_Void_Init(&pgate->m_list);
	
	_Gate_Void_Init(pgate);

}

void C_Exit(Gate* pgate)
{
	pgate->Gate_Void_Destroy(pgate);
	pgate->m_list.PortMapList_Void_Destroy(&pgate->m_list);

}

// Callback Function wrapper.  This is needed because ISO forbids a pointer to a bound
// member function.  This corrects the issue.
int GateDeviceCallbackEventHandler(Upnp_EventType EventType, void *Event, void *Cookie)
{
	return gate.GateDeviceCallbackEventHandler(&gate,EventType, Event, Cookie);
}



int main (int argc, char** argv)
{
	char *desc_doc_name=NULL, *conf_dir_path=NULL;
	char lan_ip_address[16];
	char desc_doc_url[200];
	int sig;
	sigset_t sigs_to_catch;
	int port;
	int ret;
	char *address;
	int debug =0 ;
	
	if (argc < 3)
	{
		printf( "Usage: upnpd <external ifname> <internal ifname>\n");
		printf( "Example: upnpd ppp0 eth0 \n");
		printf( "Example: upnpd eth1 eth0 \n");
		exit(0);
	}

	if( argc == 4 && strcmp(argv[3],"debug")==0 )
		debug = 1;

	if( debug == 0 )
		daemon(0,0);
	sleep(5); //wait for previous upnpd died completely
	
	//init_extensions();	//norton, inital --dport, -j DNAT, ....iptables option for libiptables.a
	if( copy_desc() != 0 )
	{
		return -1;
	}

        C_Init(&gate);

     
	//gate.m_ipcon = new IPCon(argv[2]);
	gate.m_ipcon =(IPCon*)malloc(sizeof(IPCon));
	C_IPCon_Init(gate.m_ipcon);
	gate.m_ipcon->IPCon_Init(gate.m_ipcon,argv[2]);
	
	address = gate.m_ipcon->IPCon_GetIpAddrStr(gate.m_ipcon);
	strcpy(lan_ip_address, address);
	if (address) free(address);
	
	gate.m_ipcon->IPCon_Void_Destroy(gate.m_ipcon);
	free(gate.m_ipcon);
	gate.m_ipcon=NULL;
	
	
	port = INIT_PORT;
	desc_doc_name=INIT_DESC_DOC;
	conf_dir_path=INIT_CONF_DIR;
	
	sprintf(desc_doc_url, "http://%s:%d/%s.xml", lan_ip_address, port,desc_doc_name);
//	SYS_DEBUG(LOG_DEBUG, "Intializing UPnP with desc_doc_url=%s\n",desc_doc_url);
//	SYS_DEBUG(LOG_DEBUG, "ipaddress=%s port=%d\n", lan_ip_address, port);
//	SYS_DEBUG(LOG_DEBUG, "conf_dir_path=%s\n", conf_dir_path);

	subXmlStr(conf_dir_path, "gatedesc_templet.xml", "gatedesc.xml", "!ADDR!",lan_ip_address);

/*
	system("route add -host 239.255.255.250 dev eth0");
	system("route add -host 255.255.255.255 dev eth0");
*/
	/* should not add route too late, otherwise upnpd will not accept dst 239.255.255.250:1900 query packet */
	if(addRoute(inet_addr("239.255.255.250"),0,inet_addr("255.255.255.255"),0,"eth0"))
		;//printf("Route add <239.0.0.0> OK \n");
	if(addRoute(inet_addr("255.255.255.255"),0,inet_addr("255.255.255.255"),0,"eth0"))
		;//printf("Route add <255.255.255.255> OK \n");

	if ((ret = UpnpInit(lan_ip_address, port)) != UPNP_E_SUCCESS)
	{
		SYS_DEBUG(LOG_ERR, "Error with UpnpInit -- %d\n", ret);
		UpnpFinish();
		C_Exit(&gate);
		exit(1);
	}
#if 1	
	if ((ret = UpnpSetWebServerRootDir(conf_dir_path)) != UPNP_E_SUCCESS)
	{
		SYS_DEBUG(LOG_ERR, "Error setting webserver root directory -- %s: %d\n",
			       	conf_dir_path, ret);
		UpnpFinish();
		C_Exit(&gate);
		exit(1);
	}
#endif

	write_pid();
	

	//gate.m_ipcon = new IPCon(argv[1]);
	gate.m_ipcon =(IPCon*)malloc(sizeof(IPCon));
	C_IPCon_Init(gate.m_ipcon);
	gate.m_ipcon->IPCon_Init(gate.m_ipcon,argv[1]);
	
	if ((ret = UpnpRegisterRootDevice(desc_doc_url, GateDeviceCallbackEventHandler,
				&gate.device_handle, &gate.device_handle)) != UPNP_E_SUCCESS)
	{
		SYS_DEBUG(LOG_ERR, "Error registering the rootdevice : %d\n", ret);
		UpnpFinish();
		C_Exit(&gate);
		
		if(ret==UPNP_E_TIMEDOUT)
		{
			FILE *fp;
			fp = fopen("/tmp/upnprestart","wb");
			fprintf(fp, "Something wrong ,we need restart upnp\n");
			fclose(fp);
			printf("Something wrong ,we need restart upnp !\n");
			
			notifyHttp( EVENT_UPNP_RESTART, "eth0", 0 );
		}
		{
			FILE *fp;
			fp = fopen("/tmp/upnpexit","wb");
			fprintf(fp, "Error registering the rootdevice : %d\n", ret);
			fclose(fp);
		}
		exit(1);
	}
	else
	{
		gate.GateDeviceStateTableInit(&gate,desc_doc_url);

		if ((ret = UpnpSendAdvertisement(gate.device_handle, 1800))
			!= UPNP_E_SUCCESS)
		{
			UpnpFinish();
			C_Exit(&gate);
			exit(1);
		}
	}
	
	gate.startup_time = time(NULL);
	
	//Start The Command Loop

	sigemptyset(&sigs_to_catch);
	sigaddset(&sigs_to_catch, SIGINT);
	sigaddset(&sigs_to_catch, SIGTERM);
	sigwait(&sigs_to_catch, &sig);
	
	SYS_DEBUG(LOG_INFO, "UPnP Service shutting down on signal %d...\n", sig);

	UpnpUnRegisterRootDevice(gate.device_handle);

	SYS_DEBUG(LOG_INFO, "2UPnP Service shutting down on signal %d...\n", sig);
	UpnpFinish();
	SYS_DEBUG(LOG_INFO, "3UPnP Service shutting down on signal %d...\n", sig);	
	C_Exit(&gate);
	//pt_mem_result();
	SYS_DEBUG(LOG_INFO, "4UPnP Service shutting down on signal %d...\n", sig);
	system("/sbin/iptables -t nat -F UPNP");
	
	exit(0);

}	

int subXmlStr(char *docpath, char *infile, char *outfile, char *str_from, char *str_to)
{
	FILE *fpi, *fpo;
	char pathi[256], patho[256];
	char buffi[2048], buffo[2048];
	int len_buff, len_from, len_to;
	int i, j;

	sprintf(pathi, "%s%s", docpath, infile);
	if ((fpi = fopen(pathi,"r")) == NULL) 
	{
		printf("input file can not open\n");
		return (-1);
	}

	sprintf(patho, "%s%s", docpath, outfile);
	if ((fpo = fopen(patho,"w")) == NULL) {
		printf("output file can not open\n");
		fclose(fpi);
		return (-1);
	}

	len_from = strlen(str_from);
	len_to   = strlen(str_to);

	while (fgets(buffi, 2048, fpi) != NULL) 
	{
		len_buff = strlen(buffi);
		for (i=0, j=0; i <= len_buff-len_from; i++, j++) 
		{
			if (strncmp(buffi+i, str_from, len_from)==0) 
			{
				strcpy (buffo+j, str_to);
				i += len_from - 1;
				j += len_to - 1;
			} else
			*(buffo + j) = *(buffi + i);
		}
		strcpy(buffo + j, buffi + i);
		fputs(buffo, fpo);
	}

	fclose(fpo);
	fclose(fpi);
	return (0);
}

