///////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2003 C++ to C Made by PC32 Lsshi
// All rights reserved. 

///////////////////////////////////////////////////////////////////////////*/

#include "pmlist.h"
#include "main.h"
#include <pthread.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <stdlib.h>
#include <asm/unistd.h>
#include <sys/ioctl.h>
#include <errno.h>

void Port_Free_Func(void* arg);

int Add_Upnp_Port(struct Upnp_Port *uport)
{
	char cmd[255];
	snprintf(cmd, sizeof(cmd)-1, "/sbin/iptables -t nat -A UPNP -p %s -m %s -s %s -d %s --dport %d -j DNAT --to-destination %s:%d",
		uport->Proto, uport->Proto,
		uport->RemoteIP[0] ? uport->RemoteIP : "0.0.0.0/0" ,
		uport->ExtIP, uport->ExtPort,
		uport->IntIP, uport->IntPort );
	printf("Add_Upnp_Port: %s\n", cmd);
	system ( cmd );
}

int Del_Upnp_Port(struct Upnp_Port *uport)
{
	char cmd[255];
	snprintf(cmd, sizeof(cmd)-1, "/sbin/iptables -t nat -D UPNP -p %s -m %s -s %s -d %s --dport %d -j DNAT --to-destination %s:%d",
		uport->Proto, uport->Proto,
		uport->RemoteIP[0] ? uport->RemoteIP :  "0.0.0.0/0" ,
		uport->ExtIP, uport->ExtPort,
		uport->IntIP, uport->IntPort );
	printf("Del_Upnp_Port: %s\n", cmd);
	system ( cmd );
}


void C_PortMapList_Init(struct _PortMapList* plist)
{
	
	plist->PortMapList_Void_Init=_PortMapList_Void_Init;
	plist->PortMapList_Void_Destroy=_PortMapList_Void_Destroy;
	plist->PortMapAdd=_PortMapAdd;
	plist->PortMapDelete=_PortMapDelete;
	plist->addPortForward=_addPortForward;
	plist->delPortForward=_delPortForward;
	
	PortListInit(&PORT_LIST,Port_Free_Func);
	
}


void _PortMapList_Void_Init(struct _PortMapList* plist)
{

}

void _PortMapList_Void_Destroy(struct _PortMapList* plist)
{
#if 0
	for (list<PortMap *>::iterator itr = m_pmap.begin(); itr != m_pmap.end(); itr++)
        {
		delPacketFilter((*itr)->m_PortMappingProtocol, (*itr)->m_RemoteHost,
				(*itr)->m_ExternalIP, (*itr)->m_ExternalPort);
                delPortForward((*itr)->m_PortMappingProtocol, (*itr)->m_ExternalIP,
                                (*itr)->m_ExternalPort, (*itr)->m_InternalClient,
                                (*itr)->m_InternalPort);

		delete (*itr);
        }
	m_pmap.clear();
	
#else	

	Port_ListNode* node;
	
	node=PortListHead(&PORT_LIST);

	
	while(node)
	{
						
            plist->delPortForward(PORT_ITEM->m_RemoteHost, PORT_ITEM->m_PortMappingProtocol, PORT_ITEM->m_ExternalIP,
                          PORT_ITEM->m_ExternalPort, PORT_ITEM->m_InternalClient,
                          PORT_ITEM->m_InternalPort);
                        
          //   free(PORT_ITEM);
		node=node->next;
	}
	
	PortListDestroy(&PORT_LIST,1);
	
#endif	
	
}

char Find_duplicate(char *RemoteIP, char *Proto, char *ExtIP, int ExtPort)//lsshi add 2003-8-22 12:33
{
	Port_ListNode* node;
	
	node=PortListHead(&PORT_LIST);
	
	while(node)
	{
		if (( strcmp(PORT_ITEM->m_PortMappingProtocol,Proto) == 0 ) 
			&& (PORT_ITEM->m_ExternalPort == ExtPort) )
		{
			if( RemoteIP && strcmp(PORT_ITEM->m_RemoteHost, RemoteIP) != 0)
			{
				node=node->next;
				continue;
			}
				
			return (1);
		}
		node=node->next;
	}
	
	return 0;
	
}

int _PortMapAdd(char *RemoteHost, char *Proto, char *ExtIP, int ExtPort,
		char *IntIP, int IntPort, int Enabled, char *Desc, int LeaseDuration)
{

	int fd_socket, fd_proto;
	struct sockaddr_in addr;
	PortMap *temp;
		
	
	if(Find_duplicate(RemoteHost, Proto,ExtIP,ExtPort))
	{
		printf("Find same rules,it will be droped !\n");
		return (718);
	}
	
	if ((strcmp(Proto,"TCP") == 0) || (strcmp(Proto,"tcp") == 0))
		fd_proto = SOCK_STREAM;
	else
		fd_proto = SOCK_DGRAM;
	
	if ((fd_socket = socket(AF_INET,fd_proto, 0)) == -1)
		SYS_DEBUG(LOG_DEBUG, "Socket Error");
	
	addr.sin_family = AF_INET;
	addr.sin_addr.s_addr = INADDR_ANY;
	addr.sin_port = htons(ExtPort);
	
	if (bind(fd_socket, (struct sockaddr *) &addr, sizeof(addr)) == -1)
	{
		close(fd_socket);
		SYS_DEBUG(LOG_DEBUG,"Error binding socket");
		return (718);
	}
	close (fd_socket);
	
	//temp = new PortMap;
	temp=(PortMap*)malloc(sizeof(PortMap));
	memset(temp,0,sizeof(temp));
	
	if (RemoteHost)
        {
                //temp->m_RemoteHost = new char[strlen(RemoteHost)+1];
                temp->m_RemoteHost = (char*)malloc(strlen(RemoteHost)+1);
                strcpy(temp->m_RemoteHost, RemoteHost);
        }
        else temp->m_RemoteHost = NULL;

        if (Proto)
	{
		//temp->m_PortMappingProtocol = new char[strlen(Proto)+1];
		temp->m_PortMappingProtocol = (char*)malloc(strlen(Proto)+1);
		strcpy(temp->m_PortMappingProtocol, Proto);
	}
	else temp->m_PortMappingProtocol = NULL;

        if (ExtIP)
        {
               // temp->m_ExternalIP = new char[strlen(ExtIP)+1];
                temp->m_ExternalIP = (char*)malloc(strlen(ExtIP)+1);
                strcpy(temp->m_ExternalIP, ExtIP);
        }
        else temp->m_ExternalIP = NULL;

        temp->m_ExternalPort = ExtPort;

        if (IntIP)
        {
               // temp->m_InternalClient = new char[strlen(IntIP)+1];
                temp->m_InternalClient = (char*)malloc(strlen(IntIP)+1);
                strcpy(temp->m_InternalClient, IntIP);
        }
        else temp->m_InternalClient = NULL;

        temp->m_InternalPort = IntPort;

        if (Desc)
        {
                //temp->m_PortMappingDescription = new char[strlen(Desc)+1];
                temp->m_PortMappingDescription = (char*)malloc(strlen(Desc)+1);
                strcpy(temp->m_PortMappingDescription, Desc);
        }
        else temp->m_PortMappingDescription = NULL;

        temp->m_PortMappingLeaseDuration = LeaseDuration;

	//m_pmap.push_back(temp);
	PortListAddTail(&PORT_LIST,(void*)temp);
	
	_addPortForward(RemoteHost, Proto, ExtIP, ExtPort, IntIP, IntPort, Enabled, Desc);
	
	return (1);
}


int _PortMapDelete(char *RemoteIP, char *Proto, int ExtPort)
{
#if 0	
	for (list<PortMap *>::iterator itr = m_pmap.begin(); itr != m_pmap.end(); itr++)
	{
		if (( strcmp((*itr)->m_PortMappingProtocol,Proto) == 0 ) && ((*itr)->m_ExternalPort == ExtPort))
		{
			delPacketFilter((*itr)->m_PortMappingProtocol, (*itr)->m_RemoteHost,
					(*itr)->m_ExternalIP, (*itr)->m_ExternalPort);
			delPortForward((*itr)->m_PortMappingProtocol, (*itr)->m_ExternalIP,
					(*itr)->m_ExternalPort, (*itr)->m_InternalClient,
					(*itr)->m_InternalPort);
			delete (*itr);
			m_pmap.erase(itr);
			return (1);
		}
	}
	
	
#else
	Port_ListNode* node;
	
	node=PortListHead(&PORT_LIST);
	
	while(node)
	{
		if (( strcmp(PORT_ITEM->m_PortMappingProtocol,Proto) == 0 ) 
			&& (PORT_ITEM->m_ExternalPort == ExtPort))
		{				
			if (RemoteIP && strcmp(PORT_ITEM->m_RemoteHost, RemoteIP)!=0) 
			{
				node=node->next;
				continue;
			}
				
			_delPortForward(PORT_ITEM->m_RemoteHost,  PORT_ITEM->m_PortMappingProtocol, PORT_ITEM->m_ExternalIP,
					PORT_ITEM->m_ExternalPort,PORT_ITEM->m_InternalClient,
					PORT_ITEM->m_InternalPort);
			
			PortListDelNode(&PORT_LIST,node,1);
			
			return (1);
		}
		
		node=node->next;
	
	}

#endif

	return 0;
}


int _addPortForward(char *RemoteIP, char *Proto, char *ExtIP, int ExtPort, 
	char *IntIP,int IntPort, int Enabled, char *Desc)
{
	struct Upnp_Port upnp_port;
	
	//char *address;
	memset(&upnp_port,0,sizeof(upnp_port));
	
	if(strcmp(Proto,"TCP")==0)
		strcpy(upnp_port.Proto,"tcp");
	else
	{
		
		if(strcmp(Proto,"UDP")==0)
			strcpy(upnp_port.Proto,"udp");
		else
			strcpy(upnp_port.Proto,Proto);
			
	}
		
	if( RemoteIP )
		strcpy(upnp_port.RemoteIP, RemoteIP );
	strcpy(upnp_port.ExtIP,ExtIP);
	upnp_port.ExtPort=ExtPort;
	strcpy(upnp_port.IntIP,IntIP);
	upnp_port.IntPort=IntPort;
	
	Add_Upnp_Port(&upnp_port);

	return (1);
}


int _delPortForward(char *RemoteIP, char *Proto, char *ExtIP, int ExtPort, 
	char* IntIP, int IntPort)
{
	struct Upnp_Port upnp_port;

	memset(&upnp_port,0,sizeof(upnp_port));
	
	if(strcmp(Proto,"TCP")==0)
	{
		strcpy(upnp_port.Proto,"tcp");
	}
	else
	{
		if(strcmp(Proto,"UDP")==0)
			strcpy(upnp_port.Proto,"udp");
		else
			strcpy(upnp_port.Proto,Proto);
	}

	if( RemoteIP ) 
		strcpy(upnp_port.RemoteIP, RemoteIP );
	strcpy(upnp_port.ExtIP,ExtIP);
	upnp_port.ExtPort=ExtPort;
	strcpy(upnp_port.IntIP,IntIP);
	upnp_port.IntPort=IntPort;
	
	Del_Upnp_Port(&upnp_port);

	return (1);
}

